<?php
/*
 * Plugin Name: BT BIG DATA im Browser
 * Description: Shortcode mit AG-Grid
 * Author: Benedicta Thölke
 * Version: 1.0.0
 * Author URI: https://www.bt-webdesign.de/
*/

if ( ! defined( 'ABSPATH' ) ) exit;

define( 'BT_BDB_VERSION', '1.0.0' );

function bt_bdb_enqueue_scripts(){

    wp_enqueue_script( 'ag-grid-community', plugin_dir_url(__FILE__) . 'ag-grid/js/ag-grid-community.min.js', array(), BT_BDB_VERSION, false );
    wp_enqueue_style( 'ag-grid-community-style', plugin_dir_url(__FILE__) . 'ag-grid/css/ag-grid.min.css' );
}
add_action( 'wp_enqueue_scripts', 'bt_bdb_enqueue_scripts' );

/*
 * Shortcode [bt-bdb-ag-table]
*
* @since 1.0.0
*/
function bt_bdb_ag_table( $atts ){

$styles = '<style>
           .bt_bdb_flex_row { display: flex; flex-wrap: wrap; align-content: center; align-items: baseline; padding-bottom: 15px; justify-content: space-between; }
           #bt_bdb_big_data { height: 400px; }
           </style>';

$html = '<div class="ag-wrapper bt_bdb_flex_row">
              <div id="bt_bdb_search" class="bt_bdb_flex_col"><input type="text" id="filter-text-box" placeholder="Suchen" oninput="bt_bdb_onSearchChanged()" /></div>
              <div id="bt_bdb_rows" class="bt_bdb_flex_col"><span>'. $rows .'</span> Zeilen</div>
              <div id="bt_bdb_remove" class="bt_bdb_flex_col"><button onClick="bt_bdb_removeFilter()">Alle Filter entfernen</button></div>
         </div>
         <div id="bt_bdb_big_data" class="ag-theme-quartz" ></div>';

$jsscript   = 'var gridApi; '
           .  'var columnDefs = []; ';

$jsscript  .= 'function bt_bdb_onSearchChanged() { '                                       // Suchfeld auswerten, wenn geändert
           .  '  gridApi.setGridOption( "quickFilterText", document.getElementById("filter-text-box").value, ); '
           .  '}';

$jsscript  .= 'function bt_bdb_countSelected(event) { '                                    // Anzahl selektierte Rows ausgeben
           .  '  jQuery("#bt_bdb_rows span").html( event.api.getDisplayedRowCount() ); '
           .  '}';

$jsscript  .= 'function bt_bdb_removeFilter() { '                                          // alle Filter löschen
           .  '  gridApi.setFilterModel(null); '
           .  '  document.getElementById("filter-text-box").value = ""; '
           .  '  bt_bdb_onSearchChanged(); '
           .  '}';

$jsscript  .= 'gridOptions = { '
           .  ' rowData: null, '                                                           // rowData später aus Json-Datei laden

           .  ' columnDefs: [ '
           .  '    { field: "LaenderCode" }, { field: "PLZ" }, { field: "Ort" }, { field: "Bundesland" }, { field: "BundeslandCode" }, { field: "Provinz" }, '
           .  '    { field: "ProvinzCode" }, { field: "Gemeinde" }, { field: "GemeindeCode" }, { field: "Latitude" }, { field: "Longitude" }, { field: "Accuracy" } '
           .  ' ], '

           . '  onFilterChanged: bt_bdb_countSelected, '                                    // Anzahl Zeilen anpassen

           . '  autoSizeStrategy: { '
           . '     type: "fitCellContents", '                                               // fitCellContents
           . '     }, '

           . '  defaultColDef: { '
           . '    filter: true '                                                            // Filter in jeder Column
           . '  }, '

           . '}; ';

$jsscript  .= 'gridDiv = document.querySelector("#bt_bdb_big_data"); '
           .  'gridApi = agGrid.createGrid(gridDiv, gridOptions); ';

$jsscript .= ' url = "'. plugins_url('/data/' , __FILE__) . 'big-data-plz-latitude-longitude.json' .'";'

         . '  fetch( url ) '
         . '		.then( response => response.json ()) '
         . '    .then( rowData => {  '
         . '                     gridApi.setGridOption( "rowData", rowData ); '
         . '                     jQuery("#bt_bdb_rows span").html( rowData.length ); '
         . '                     });  ';

return $styles . $html . '<script>'. $jsscript .'</script>';
}

add_shortcode('bt-bdb-ag-table', 'bt_bdb_ag_table');
?>